function invert() {
  if (kara.onLeaf()) {
    kara.removeLeaf();
  }
  else {
    kara.putLeaf();
  }
} 

function walk() {
  invert();
  while (!kara.treeFront()) {
    kara.move();
    invert();
  }
} 

function left2right() {
  walk();
  if (!kara.treeRight()) {
    kara.turnRight();
    kara.move();
    kara.turnRight();
  }
}

function right2left() {
  walk();
  if (!kara.treeLeft()) {
    kara.turnLeft();
    kara.move();
    kara.turnLeft();
  }
}


var walkingLeft2Right = true;

while (!( kara.treeFront() && 
          (kara.treeLeft() || kara.treeRight()) )) {
  if (walkingLeft2Right) {
    left2right();
  }
  else {
    right2left();
  }
  walkingLeft2Right = !walkingLeft2Right;
}
