/*******************************************************************************
 * Kara schaut dem "Spiel des Lebens" zu. Damit das Programm einfacher wird,
 * greift das Programm direkt auf den "Speicher" der Welt zu. Dafr stehen
 * einige Methoden des Objekts world zur Verfgung (siehe
 * unten). Zudem muss regelmssig die Methode tools.checkState()
 * aufgerufen werden. Diese Methode schaut auf den Geschwindigkeitsregler
 * im JavaKara-Hauptprogramm und legt das Programm eine entsprechende
 * Zeitdauer schlafen.
 *
 ******************************************************************************/
function countNeighborsIncl (cells, y, x) {
  count = 0;
  for (i = y-1; i <= y+1; i++) {
    for (j= x-1; j <= x+1; j++) {
      if (cells[i][j]) {
        count++;
      }
    }
  }
  return count;
}

function newCellValue (cells, y, x) {
  neighbors = countNeighborsIncl (cells, y, x);
  if (cells[y][x]) {
    neighbors = neighbors-1; // Zelle selbst zhlt nicht
    return (neighbors == 2) || (neighbors == 3);
  }
  else {
    return (neighbors == 3);
  }
}

SIZE_X = world.getSizeX();
SIZE_Y = world.getSizeY();

// mit dem folgenden Code kann die Welt zufllig
// initialisiert werden
/*
for (y = 1; y < SIZE_Y-1; y++) {
  for (x = 1; x < SIZE_X-1; x++) {
    r = tools.random(1);
    world.setLeaf (x, y, r == 1);
  }
}
tools.checkState();
*/

cells    = Array();
newCells = Array();

cells[0] = Array();
newCells[0] = Array();

for (y = 1; y < SIZE_Y-1; y++) {
  cells[y] = Array();
  newCells[y] = Array();
  for (x = 1; x < SIZE_X-1; x++) {
    cells[y][x] = world.isLeaf (x, y);
  }
}

cells[SIZE_Y-1] = Array();
newCells[SIZE_Y-1] = Array();

while (true) {
  for (y = 1; y < SIZE_Y-1; y++) {
    for (x = 1; x < SIZE_X-1; x++) {
      newCells[y][x] = newCellValue (cells, y, x);
    }
  }

  for (y = 1; y < SIZE_Y-1; y++) {
    for (x = 1; x < SIZE_X-1; x++) {
      cells[y][x] = newCells[y][x];
      world.setLeaf (x, y, cells[y][x]);
    }
  }
  tools.checkState();
}
