function forward(n) {
  for (j = 0; j < n; j++) {
    if (!kara.onLeaf()) {
      kara.putLeaf();
    }
    kara.move();
  }
}

function replace (string, find, replace) {
  result = "";
  index = 0;

  while (index <= string.length-find.length) {
    currentSubString = 
       string.substring(index, index+find.length);

    if (currentSubString.equals(find)) {
      result += replace;
      index  += find.length;
    }
    else {
      result += currentSubString;
      index++;
    }
  }

  return result;
}

function interpret (string, stepLength) {
  for (i = 0; i < string.length; i++) {
    if (string[i] == "F") {
      forward(stepLength);
    }
    else if (string[i] == "L") {
      kara.turnLeft();
    }
    else if (string[i] == "R") {
      kara.turnRight();
    }
  }
}

GENERATOR_FIND = "F";
GENERATOR_REPLACE = "FLFRFRFLF";
ITERATIONS = 3;

string = "FF";

for (k = 0; k < ITERATIONS; k++) {
  world.clearAll();
  kara.setPosition (0, world.getSizeY()-1);
  interpret (string, 3);
  tools.sleep(500);
  string = replace (string, GENERATOR_FIND, GENERATOR_REPLACE);
}

world.clearAll();
kara.setPosition (0, world.getSizeY()-1);
interpret (string, 3);
