ITERATIONS = 100

X_MIN = -2
X_MAX = 1.4
Y_MIN = -2
Y_MAX = 1.4

def test (x, y):
  tmpX = 0
  tmpY = 0
  i = 0
  while ((tmpX*tmpX + tmpY*tmpY) <= 4) and (i < ITERATIONS):
    tmp2X = 0
    tmp2Y = 0
    i = i + 1
    tmp2X = tmpX*tmpX - tmpY*tmpY + x
    tmp2Y = 2*tmpX*tmpY + y
    tmpX = tmp2X
    tmpY = tmp2Y
  return  i

def calculateMandelX (col):
  return X_MIN + col * (X_MAX-X_MIN) / KARA_WIDTH

def calculateMandelY (row):
  return Y_MIN + row * (Y_MAX-Y_MIN) / KARA_HEIGHT

KARA_WIDTH = world.getSizeX()
KARA_HEIGHT= world.getSizeY()

world.clearAll()

for row in range (0, KARA_HEIGHT):
  for col in range (0, KARA_WIDTH):
    x = calculateMandelX(col)
    y = calculateMandelY(row)

    i = test(x, y)
    if i == ITERATIONS:
      world.setLeaf(col, row, 1)
      tools.checkState()

