def invert(kara)
  if kara.onLeaf
    kara.removeLeaf
  else
    kara.putLeaf
  end
end

def walk(kara)
  invert(kara)
  while not kara.treeFront
    kara.move
    invert(kara)
  end
end

def left2right(kara)
  walk(kara)
  if not kara.treeRight
    kara.turnRight
    kara.move
    kara.turnRight
  end
end

def right2left(kara)
  walk(kara)
  if not kara.treeLeft
    kara.turnLeft
    kara.move
    kara.turnLeft
  end
end

walkingLeft2Right = true

while not (kara.treeFront and (kara.treeLeft or kara.treeRight))
  if walkingLeft2Right 
    left2right(kara)
  else
    right2left(kara)
  end
  walkingLeft2Right = !walkingLeft2Right
end
